require 'cli_metric_collector/version'

class CliMetricCollector
  VERSION = CliMetricCollectorVersion

  class << self
    attr_accessor :endpoint
  end

  self.endpoint = nil

  def self.capture(name, payload = {})
    new(name, payload).sendout
  end

  attr_reader :name, :extra

  def initialize(name, extra = {})
    @name = name
    @extra = extra
  end

  def sendout
    if self.class.endpoint
      pid = fork
      pid ? Process.detach(pid) : exec(command)
    else
      puts "CliMetricCollector is missing the endpoint, nothing sent" 
    end
  end

  private

  def json
    require "json"
    data.to_json
  end

  def data
    { :name => name, :data => extra }
  end

  def command
    [
      "curl", 
      "-XPOST",
      "-H 'Content-Type: application/json'",
      "-d '#{json}'",
      self.class.endpoint,
      "> /dev/null 2>&1"
    ].join(" ")
  end

end

